//id_distribute_=_0mm.jsx　2017.06.23（z-）ver_d
//規定値で等間隔に分布する
//規定値はスクリプトのファイル名で指定する
//ファイル名は "_垂直水平_値 + 単位 .jsx" とする
//水平分布は"!!"、垂直分布は"=" と表記する
// " _||_2.5mm.jsx"、"_=_4pt.jsx" など

//2017.06.27　ver_b　Windows環境ではファイル名に"||"を使用できないとの事で"!!"に変更
//2017.09.22　ver_c　キーオブジェクト未指定の際の挙動を改善
//2017.11.13　ver_d　||→!! に変更した際のbreak処理の入れ忘れ修正

//ドキュメントが開かれていて選択オブジェクトが2つ以上あるか見ている
try{
    app.selection[1].name;
    }
catch(e){
    exit();
    }

var doc = app.activeDocument;
var sel = app.selection;

//ファイル名の調査

//"_="から拡張子の直前までを拾っている
var fileName = decodeURI($.fileName).match(/_(=||\!\!)_\d*\.?\d*?[a-z]*(?=\.jsx$)/);
if(fileName == null){
    alert("ファイル名のエラーです\n\n詳しくはwebで");
    exit();
    }
fileName = fileName[0];

//引数のピッカップ
var vh = fileName.match(/^.+?(?=_)/)[0];
switch(vh){
    case "_=" : vh = DistributeOptions.VERTICAL_SPACE;
                    break;
    case "_!!" : vh = DistributeOptions.HORIZONTAL_SPACE;
                    break;
    case "_||" : alert("エラー：\nすみませんが水平分布の場合は「||」→「!!」に変更となりました"); exit();
    }

//_=を飛ばして間隔に使う
var val = fileName.replace(/^[^\d\.]+/, "");

try{
doc.distribute(
    sel, 
    vh, 
    app.selectionKeyObject ? AlignDistributeBounds.KEY_OBJECT : undefined,  
    true, 
    val, 
    app.selectionKeyObject ? app.selectionKeyObject : undefined
    );
} catch(e){
    alert("エラー：\nたぶん単位の表記が無効です");
    }